package visitor._1_double_dispatch.example;

import java.util.ArrayList;
import java.util.List;

import visitor._1_double_dispatch.shared.SingleVisitable;
import visitor._1_double_dispatch.shared.SingleVisitor;
import visitor._1_double_dispatch.to_visit.S1;
import visitor._1_double_dispatch.to_visit.S2;

/**
 * Konkrete (finale) Besucher-Klasse
 * fr konkrete Instanzen des
 * Interface {@link SingleVisitable}.
 * 
 * @author Heiner K&uuml;cker
 */
final class ExampleSingleVisitor
implements SingleVisitor
{
    /**
     * Ergebnis-Sammler-Liste
     */
    final List<String> resultList = new ArrayList<>();

    /**
     * Im Visitor-Konstrukt aufzurufende Methode fr die Klasse
     * {@link S1}.
     * 
     * @see SingleVisitor#visitS1
     */
    @Override
    public void visitS1(
            final S1 s1 )
    {
        final String resultStr =
                new Exception().getStackTrace()[ 0 ].getMethodName() +
                ":" +
                s1.getClass().getSimpleName();

        System.out.println( resultStr );

        this.resultList.add( resultStr );
    }

    /**
     * Im Visitor-Konstrukt aufzurufende Methode fr die Klasse
     * {@link S2}.
     * 
     * @see SingleVisitor#visitS2
     */
    @Override
    public void visitS2(
            final S2 s2 )
    {
        final String resultStr =
                new Exception().getStackTrace()[ 0 ].getMethodName() +
                ":" +
                s2.getClass().getSimpleName();

        System.out.println( resultStr );

        this.resultList.add( resultStr );
    }

}
