package visitor._1_double_dispatch.example;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import junit.framework.Assert;

import org.junit.Test;

import visitor._1_double_dispatch.shared.SingleVisitable;
import visitor._1_double_dispatch.to_visit.S1;
import visitor._1_double_dispatch.to_visit.S2;

/**
 * JUnit4-Testcase fr die Klasse {@link ExampleSingleVisitor}.
 * 
 * @author Heiner K&uuml;cker
 */
public class ExampleSingleVisitorTest
{
    /**
     * Test method for {@link ExampleSingleVisitor}.
     */
    @Test
    @SuppressWarnings( "static-method" )
    public final void testVisit()
    {
        // zur Vereinfachung wird statt eines Baumes nur eine Liste der besuchbaren Objekte aufgebaut
        final List<? extends SingleVisitable> sListToVisit =
                Arrays.asList(
                        new S1() ,
                        new S2() );

        final ExampleSingleVisitor visitor =
                new ExampleSingleVisitor();

        for ( final SingleVisitable s : sListToVisit )
        {
            s.accept( visitor );
        }

        Assert.assertEquals(
                //expected
                new ArrayList<>(
                        Arrays.asList(
                                "visitS1:" + ( new S1() ).getClass().getSimpleName() ,
                                "visitS2:" + ( new S2() ).getClass().getSimpleName() ) ) ,
                //actual
                visitor.resultList );
    }

}
