package visitor._1_double_dispatch.shared;

import visitor._1_double_dispatch.to_visit.S1;
import visitor._1_double_dispatch.to_visit.S2;

/**
 * Beispiel Visitable-Interface Single-Dispatch
 * zum Besuchen von Instanzen der Klasse
 * {@link S1} oder {@link S2}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface SingleVisitable
{
    /**
     * Zu implementierende Methode zum
     * Realisieren der Besuchbarkeit
     * einer Instanz der implementierenden
     * Klasse.
     * 
     * @param visitor Besucher
     */
    public void accept(
            final SingleVisitor visitor );
}
