package visitor._1_double_dispatch.shared;

import visitor._1_double_dispatch.to_visit.S1;
import visitor._1_double_dispatch.to_visit.S2;

/**
 * Beispiel Visitor-Interface Single-Dispatch
 * zum Besuchen von Instanzen des Interface
 * {@link SingleVisitable}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface SingleVisitor
{
    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link S1}.
     * 
     * @param s1 Instanz der Klasse {@link S1}
     */
    public void visitS1(
            final S1 s1 );

    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link S2}.
     * 
     * @param s2 Instanz der Klasse {@link S2}
     */
    public void visitS2(
            final S2 s2 );
}
