package visitor._2_multi_dispatch.example;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import junit.framework.Assert;

import org.junit.Test;

import visitor._2_multi_dispatch.shared.AVisitable;
import visitor._2_multi_dispatch.shared.BVisitable;
import visitor._2_multi_dispatch.to_visit.A1;
import visitor._2_multi_dispatch.to_visit.A2;
import visitor._2_multi_dispatch.to_visit.B1;
import visitor._2_multi_dispatch.to_visit.B2;

/**
 * JUnit4-Testcase fr die Klasse {@link ExampleABProcessor}.
 * 
 * @author Heiner K&uuml;cker
 */
public class ExampleABMultiVisitorTest
{
    /**
     * Test method for {@link ExampleABProcessor}.
     */
    @Test
    @SuppressWarnings( "static-method" )
    public final void test()
    {
        // zur Vereinfachung wird statt eines Baumes nur eine Liste der besuchbaren Objekte aufgebaut
        final List<? extends AVisitable> aListToVisit =
                Arrays.asList(
                        new A1() ,
                        new A2() );

        // zur Vereinfachung wird statt eines Baumes nur eine Liste der besuchbaren Objekte aufgebaut
        final List<? extends BVisitable> bListToVisit =
                Arrays.asList(
                        new B1() ,
                        new B2() );

        final ExampleABProcessor abProcessor =
                new ExampleABProcessor();

        for ( final AVisitable a : aListToVisit )
        {
            for ( final BVisitable b : bListToVisit )
            {
                abProcessor.accept(
                        a ,
                        b );
            }
        }

        Assert.assertEquals(
                //expected
                new ArrayList<>(
                        Arrays.asList(
                                "processA1B1:" + ( new A1() ).getClass().getSimpleName() + "-" + ( new B1() ).getClass().getSimpleName() ,
                                "processA1B2:" + ( new A1() ).getClass().getSimpleName() + "-" + ( new B2() ).getClass().getSimpleName() ,
                                "processA2B1:" + ( new A2() ).getClass().getSimpleName() + "-" + ( new B1() ).getClass().getSimpleName() ,
                                "processA2B2:" + ( new A2() ).getClass().getSimpleName() + "-" + ( new B2() ).getClass().getSimpleName() ) ) ,
                //actual
                abProcessor.resultList );
    }
}
