package visitor._2_multi_dispatch.shared;

import visitor._2_multi_dispatch.to_visit.A1;
import visitor._2_multi_dispatch.to_visit.A2;

/**
 * Beispiel Visitable-Interface Multi-Dispatch
 * zum Besuchen von Instanzen der Klassen
 * {@link A1} oder {@link A2}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface AVisitable
{
    /**
     * Zu implementierende Methode zum
     * Realisieren der Besuchbarkeit
     * einer Instanz der implementierenden
     * Klasse.
     * 
     * @param visitor Besucher fr eine Instanz des Interface {@link AVisitable}
     */
    public void accept(
            final AVisitor visitor );
}
