package visitor._2_multi_dispatch.shared;

import visitor._2_multi_dispatch.to_visit.A1;
import visitor._2_multi_dispatch.to_visit.A2;

/**
 * Beispiel Visitor-Interface Multi-Dispatch
 * zum Besuchen von konkreten Ableitungs-Instanzen 
 * des Interface {@link AVisitable}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface AVisitor
{
    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link A1}.
     * 
     * @param a1 Instanz der Klasse {@link A1}
     */
    public void visitA1(
            final A1 a1 );

    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link A2}.
     * 
     * @param a2 Instanz der Klasse {@link A2}
     */
    public void visitA2(
            final A2 a2 );
}
