package visitor._2_multi_dispatch.shared;

import visitor._2_multi_dispatch.to_visit.B1;
import visitor._2_multi_dispatch.to_visit.B2;

/**
 * Beispiel Visitable-Interface Multi-Dispatch
 * zum Besuchen von Instanzen der Klassen
 * {@link B1} oder {@link B2}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface BVisitable
{
    /**
     * Zu implementierende Methode zum
     * Realisieren der Besuchbarkeit
     * einer Instanz der implementierenden
     * Klasse.
     * 
     * @param visitor Besucher
     */
    public void accept(
            final BVisitor visitor );
}
