package visitor._2_multi_dispatch.shared;

import visitor._2_multi_dispatch.to_visit.B1;
import visitor._2_multi_dispatch.to_visit.B2;

/**
 * Beispiel Visitor-Interface Multi-Dispatch
 * zum Besuchen von konkreten Ableitungs-Instanzen 
 * des Interface {@link BVisitable}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface BVisitor
{
    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link B1}.
     * 
     * @param b1 Instanz der Klasse {@link B1}
     */
    public void visitB1(
            final B1 b1 );

    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link B2}.
     * 
     * @param b2 Instanz der Klasse {@link B2}
     */
    public void visitB2(
            final B2 b2 );
}
