package visitor._3_multi_dispatch.shared;

/**
 * Abstrakte Oberklasse zum
 * Zusammenfassen der Gemeinsamkeiten
 * der Klassen
 * TODO
 * 
 * @author Heiner K&uuml;cker
 */
abstract class AbstractCDSwitchVisitor
implements DVisitor
{
    /**
     * Vom Benutzer zu implementierende Multi-Dispatch-Visitor-Klasse
     * fr Implementierungsklassen der Interfaces {@link CVisitable}, 
     * {@link DVisitable} sowie {@link EVisitable}.
     */
    protected final CDEProcessor cdeProcessor;

    /**
     * Vernderliche Member zum Vermerken des
     * ausgwhlten nchsten Visitors.
     * <br/>
     * Dies erlaubt im Interface {@link DVisitor}
     * wie in vielen Visitor-Beispielen
     * gezeigt, die Verwendung von void-Methoden.
     * <br/>
     * Falls doch noch ein Return-Wert in die
     * visit-Methoden eingefhrt wird, soll
     * dieser fr den Benutzer des Visitors
     * reserviert bleiben.
     */
    EVisitor eVisitor;

    /**
     * Konstruktor.
     * 
     * @param cdeProcessor Verarbeiter-Visitor-Instanz mit konkretem(implementiertem) Besuchs-Code
     */
    AbstractCDSwitchVisitor(
            final CDEProcessor cdeProcessor )
    {
        if ( cdeProcessor == null )
        {
            throw new IllegalArgumentException(
                    "cdeProcessor is null" );
        }
        this.cdeProcessor = cdeProcessor;
    }

    

}
