package visitor._3_multi_dispatch.shared;

import visitor._3_multi_dispatch.to_visit.C1;
import visitor._3_multi_dispatch.to_visit.C2;

/**
 * Beispiel Visitable-Interface Multi-Dispatch
 * zum Besuchen von Instanzen der Klassen
 * {@link C1} und {@link C2}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface CVisitable
{
    /**
     * Zu implementierende Methode zum
     * Realisieren der Besuchbarkeit
     * einer Instanz der implementierenden
     * Klasse.
     * 
     * @param visitor Visitor zum Erzeugen des spezialisierten {@link DVisitor} zum Realisieren des Multi-Dispatch
     *                Besucher fr eine Instanz der Klasse {@link CVisitable}
     */
    public void accept(
            final CVisitor visitor );
}
