package visitor._3_multi_dispatch.shared;

import visitor._3_multi_dispatch.to_visit.C1;
import visitor._3_multi_dispatch.to_visit.C2;

/**
 * Beispiel Visitor-Interface Multi-Dispatch
 * zum Besuchen von Instanzen der Klasse
 * {@link C1} oder {@link C2}, welche
 * das besuchbare Interface {@link CVisitable}
 * implementieren.
 * 
 * @author Heiner K&uuml;cker
 */
public interface CVisitor
{
    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link C1}.
     * 
     * @param c1 Instanz der Klasse {@link C1}
     */
    public void visitC1(
            final C1 c1 );

    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link C2}.
     * 
     * @param c2 Instanz der Klasse {@link C2}
     */
    public void visitC2(
            final C2 c2 );
}
