package visitor._3_multi_dispatch.shared;

import visitor._3_multi_dispatch.to_visit.D1;
import visitor._3_multi_dispatch.to_visit.D2;

/**
 * Beispiel Visitable-Interface Multi-Dispatch
 * zum Besuchen von Instanzen der Klassen
 * {@link D1} und {@link D2}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface DVisitable
{
    /**
     * Zu implementierende Methode zum
     * Realisieren der Besuchbarkeit
     * einer Instanz der implementierenden
     * Klasse.
     * 
     * @param visitor Visitor zum Erzeugen des spezialisierten {@link DVisitor} zum Realisieren des Multi-Dispatch
     *                Besucher fr eine Instanz der Klasse {@link DVisitable}
     */
    public void accept(
            final DVisitor visitor );
}
