package visitor._3_multi_dispatch.shared;

import visitor._3_multi_dispatch.to_visit.D1;
import visitor._3_multi_dispatch.to_visit.D2;

/**
 * Beispiel Visitor-Interface Multi-Dispatch
 * zum Besuchen von Instanzen der Klasse
 * {@link D1} oder {@link D2}, welche
 * das besuchbare Interface {@link DVisitable}
 * implementieren.
 * 
 * @author Heiner K&uuml;cker
 */
public interface DVisitor
{
    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link D1}.
     * 
     * @param d1 Instanz der Klasse {@link D1}
     */
    public void visitD1(
            final D1 d1 );

    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link D2}.
     * 
     * @param d2 Instanz der Klasse {@link D2}
     */
    public void visitD2(
            final D2 d2 );
}
