package visitor._3_multi_dispatch.shared;

import visitor._3_multi_dispatch.to_visit.E1;
import visitor._3_multi_dispatch.to_visit.E2;

/**
 * Beispiel Visitable-Interface Multi-Dispatch
 * zum Besuchen von Instanzen der Klassen
 * {@link E1} und {@link E2}.
 * 
 * @author Heiner K&uuml;cker
 */
public interface EVisitable
{
    /**
     * Zu implementierende Methode zum
     * Realisieren der Besuchbarkeit
     * einer Instanz der implementierenden
     * Klasse.
     * 
     * @param visitor Besucher fr eine Instanz der Klasse {@link EVisitable}
     */
    public void accept(
            final EVisitor visitor );
}
