package visitor._3_multi_dispatch.shared;

import visitor._3_multi_dispatch.to_visit.E1;
import visitor._3_multi_dispatch.to_visit.E2;

/**
 * Beispiel Visitor-Interface Multi-Dispatch
 * zum Besuchen von Instanzen der Klasse
 * {@link E1} oder {@link E2}, welche
 * das besuchbare Interface {@link EVisitable}
 * implementieren.
 * 
 * @author Heiner K&uuml;cker
 */
public interface EVisitor
{
    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link E1}.
     * 
     * @param e1 Instanz der Klasse {@link E1}
     */
    public void visitE1(
            final E1 e1 );

    /**
     * Zu implementierende Methode zum Besuchen 
     * einer Instanz der Klasse {@link E2}.
     * 
     * @param e2 Instanz der Klasse {@link E2}
     */
    public void visitE2(
            final E2 e2 );
}
