package visitor._3_multi_dispatch.to_visit;

import visitor._3_multi_dispatch.shared.EVisitable;
import visitor._3_multi_dispatch.shared.EVisitor;

/**
 * Erste konkrete besuchbare Implementierungs-Klasse
 * des Interface {@link EVisitable}.
 * 
 * @author Heiner K&uuml;cker
 */
public final class E1
implements EVisitable
{
    /**
     * @see EVisitable#accept
     */
    @Override
    public void accept(
            final EVisitor visitor )
    {
        visitor.visitE1(
                this );
    }

    /**
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString()
    {
        return this.getClass().getSimpleName();
    }
}
